<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Wifi Configuration</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		#main_body {
			visibility: hidden;
		}

		.wifi_params {
			background: #007bff;
			color: white;
			border-radius: .2rem;
			font-size: smaller;
		}

		.section_line {
			height: 1rem;
		}

		.input-group {
			font-size: smaller;
		}

		#div_static_ip :disabled {
			text-decoration: line-through;
		}

		.wifi_param_key {
			text-align: right;
			padding: 0.2rem !important;
		}

		.wifi_param_value {
			font-weight: 600;
			padding: 0.2rem !important;
		}

		.param_ip_address {
			color: red;
		}

		#wifi_params_table {
			font-size: x-small;
		}

		#wifi_list_table {
			font-size: x-small;
		}

		.ip_address_class {
			font-size: small;
		}

		.courier_new {
			font-family: "Courier New", Courier, monospace;
			font-weight: bold;
		}

		#button_copy_ip {
			font-size: x-small;
			color: white;
		}

		a:hover {
			cursor: pointer;
		}
	</style>


</head>

<body>
	<div id="main_body">
		<div w3-include-html="meti_bst.html"></div>

		<div class="container1">
			<div class="row m-0 p-0">
				<main role="main" class="col-md-11 m-2">
					<h5 class="p-1">Wifi Configuration</h5>
					<div class="row">
						<div class="col-sm-5 p-1">
							<form id="formID">
								<div class="border border-primary p-2">
									<!-- Enable Wifi Station Mode -->
									<div class="input-group mb-3 mt-1">
										<div class="input-group-prepend">
											<div class="input-group-text">
												<input type="checkbox" id="wifi_sta_enabled">
											</div>
										</div>
										<label type="text" class="form-control">Enable Wifi Station Mode</label>
										<div class="meti_loader m-1" id="loader_get_ip"
											style="width:1.5rem; height:1.5rem"></div>
									</div>

									<div class="wifi_settings">
										<!-- Device ID -->
										<div class="form-group p-0 m-1 row">
											<label class="col-4" for="device_id">Device Id</label>
											<input type="text" id="device_id" name="device_id"
												class="col-8 form-control form-control-sm" readonly>
										</div>

										<!-- wifi ssid -->
										<div class="form-group p-0 m-1 row">
											<label class="col-4" for="wifi_ssid">Wifi SSID</label>
											<input type="text" id="wifi_ssid" name="wifi_ssid"
												class="col-8 form-control form-control-sm" autocomplete="off"
												data-validation-engine="validate[required], maxSize[31]">
										</div>

										<!-- wifi password -->
										<div class="form-group p-0 m-1 row">
											<label class="col-4" for="wifi_password">Password</label>
											<input type="password" id="wifi_password" name="wifi_password"
												class="col-8 form-control form-control-sm" autocomplete="new-password"
												data-validation-engine="validate[required], maxSize[24]">
										</div>

										<div id="div_static_ip" class="collapse">
											<a id="button_copy_ip" class="btn btn-sm btn-danger">Copy active
												settings</a>
											<!-- Static IP_Address -->
											<div class="form-group p-0 m-1 row">
												<div class="col-4">
													<label for="static_ip">Static IP</label>
												</div>
												<div class="col-8 input-group-prepend p-0">
													<input type="text" id="static_ip" name="static_ip"
														class="form-control form-control-sm courier_new param_ip_address"
														data-validation-engine="validate[required, custom[ipv4]]"
														autocomplete="off">
												</div>
											</div>

											<!-- Static Gateway Address -->
											<div class="form-group p-0 m-1 row">
												<label class="col-4" for="static_gw">Gateway</label>
												<div class="col-8 input-group-prepend p-0">
													<input type="text" id="static_gw" name="static_gw"
														class="form-control form-control-sm courier_new"
														data-validation-engine="validate[required, custom[ipv4]]">
												</div>
											</div>

											<!-- Static Subnet mask Address -->
											<div class="form-group p-0 m-1 row">
												<label class="col-4" for="static_sn">Subnet</label>
												<div class="col-8 input-group-prepend p-0">
													<input type="text" id="static_sn" name="static_sn"
														class="form-control form-control-sm courier_new"
														data-validation-engine="validate[required, custom[ipv4]]">
												</div>
											</div>

											<!-- Static DNS Address -->
											<div class="form-group p-0 m-1 row">
												<label class="col-4" for="static_dns">DNS</label>
												<div class="col-8 input-group-prepend p-0">
													<input type="text" id="static_dns" name="static_dns"
														class="form-control form-control-sm courier_new"
														data-validation-engine="validate[required, custom[ipv4]]">
												</div>
											</div>
										</div>
									</div>

									<!-- Buttons -->
									<div class="form-group row mt-4 mb-1">
										<button type="button" id="button_static_ip"
											class="btn btn-danger btn-sm col-4 ml-2 mr-2" data-toggle="collapse"
											data-target="#div_static_ip" aria-expanded="false">Enable Static IP</button>
										<button type="button" id="button_cancel"
											class="btn btn-warning col ml-1 mr-1">Cancel</button>
										<button type="button" id="button_save"
											class="btn btn-success col ml-1 mr-1">Save</button>
										<button type="button" id="button_test" class="btn btn-primary col ml-1 mr-2">Get
											IP</button>
									</div>
								</div>
							</form>
						</div>
						<div class="col-sm-3 p-1">
							<div class="wifi_params border border-primary p-1">
								<table id="wifi_params_table" class="table table-sm table-primary m-0">
									<tbody id="wifi_params_table_body">
										<!-- Current Wifi parameters will be listed here...-->
									</tbody>
								</table>
							</div>
						</div>
						<div class="col-sm-4 p-1">
							<div class="border border-primary p-1">
								<div class="row">
									<button type="button" id="button_scan" class="btn btn-info btn-sm m-1 ml-3">Scan
										Wifi</button>
									<div id="loader_scan" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
									</div>
								</div>
								<div>
									<table id="wifi_list_table" class="table table-sm table-primary table-hover">
										<thead>
											<tr>
												<th scope="col">#</th>
												<th scope="col">SSID</th>
												<th scope="col">Signal</th>
												<th scope="col">Security</th>
											</tr>
										</thead>
										<tbody id="table_body">
											<!-- Wifi list comes here... -->
										</tbody>
									</table>
								</div>
							</div>
						</div>
					</div>
				</main>
			</div>
		</div>
	</div>
</body>

</html>

<script>

	w3IncludeHTML();

	$(document).ready(function () {
		$("#main_body").css("visibility", "visible");
		//Enable the validation engine
		$("#formID").validationEngine();
		$(".loader_scan").css("display", "none");

		// display all items
		$(".conn_status :input").attr("disabled", true);

		$("#div_static_ip").on("hidden.bs.collapse", function () {
			$("#button_static_ip")
				.removeClass('btn-success')
				.addClass('btn-danger')
				.html('Enable Static IP');

			enable_disable_copy_button();
		});

		$("#div_static_ip").on("shown.bs.collapse", function () {
			$("#button_static_ip")
				.removeClass('btn-danger')
				.addClass('btn-success')
				.html('Disable Static IP');

			enable_disable_copy_button();
		});

		$("#button_save").on("click", function () {
			// Check if the form passes the validation test....
			if ($("#formID").validationEngine('validate')) {
				var r = confirm("Save the configuration?");
				if (r == true) {
					save_config(0);
				}
			}
		});

		$("#button_test").on("click", function () {
			// Check if the form passes the validation test....
			if ($("#formID").validationEngine('validate')) {
				$("#loader_get_ip").css("display", "block");
				$(".ip_address_class").html("");
				save_config(1);
			}
		});

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		$("#wifi_sta_enabled").on("click", function () {
			enable_disable();
		});

		function enable_disable() {
			if ($('#wifi_sta_enabled').is(":checked") == true) {
				$(".wifi_settings :input").attr("disabled", false);
			} else {
				$(".wifi_settings :input").attr("disabled", true);
			}
		}

		$(".static_params").on("click", function () {
			enable_disable_static($(this));
		})

		function enable_disable_static(obj) {
			var id = "#" + $(obj).attr("for");

			if ($(obj).is(":checked") == true) {
				$(id).attr("disabled", false)
			} else {
				$(id).attr("disabled", true)
			}
		}

		function load_form_data() {
			// get data from the global parameters

			$('#wifi_sta_enabled').prop("checked", g_wifi_db.sta_enabled);

			var g_wf_w1 = g_wifi_db.w1;
			$("#wifi_ssid").val(g_wf_w1.ssid);
			$("#wifi_password").val(g_wf_w1.pw);

			var g_w1_static = g_wifi_db.w1.static;

			$("#static_ip").val(g_w1_static.ip);
			$("#static_gw").val(g_w1_static.gw);
			$("#static_sn").val(g_w1_static.sn);
			$("#static_dns").val(g_w1_static.dns);

			enable_disable();

			if (g_w1_static.en == true) {
				$("#button_static_ip").click();
			}
		}

		function enable_disable_copy_button() {
			var ap_mode = false;

			var mode = $("#active_Mode").html();
			if (mode == "FORCED ACCESS POINT" || mode == "ACCESS POINT") {
				ap_mode = true;
			}

			var show_copy_button = false;
			if (ap_mode == true) {
				if ($("#button_static_ip").attr("aria-expanded") == "true") {
					show_copy_button = true;
				}
			}

			if (show_copy_button == true) {
				$("#button_copy_ip").css("display", "inline");
			} else {
				$("#button_copy_ip").css("display", "none");
			}
		}

		$("#button_copy_ip").on("click", function () {
			$("#static_ip").val($("#active_IP_Address").html());
			$("#static_gw").val($("#active_Gateway").html());
			$("#static_sn").val($("#active_Subnet").html());
			$("#static_dns").val($("#active_Gateway").html());
		});

		function save_config(wifi_test) {
			var debug = 0;

			g_wifi_db.sta_enabled = $("#wifi_sta_enabled").is(":checked");

			g_w1 = g_wifi_db.w1;
			g_w1.ssid = $("#wifi_ssid").val();
			g_w1.pw = $("#wifi_password").val();

			var g_w1_static = g_wifi_db.w1.static;

			//JSON.parse here converts "true" to true....
			g_w1_static.en = JSON.parse($("#button_static_ip").attr("aria-expanded"))

			g_w1_static.ip = $("#static_ip").val();
			g_w1_static.gw = $("#static_gw").val();
			g_w1_static.sn = $("#static_sn").val();
			g_w1_static.dns = $("#static_dns").val();

			var url = "/updateWifiConfig";
			var type = 'POST';
			var data = {
				wifi_config: JSON.stringify(g_wifi_db),
				wifi_test: wifi_test
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;
						
						//do not show alert in wifi test mode (get ip)
						if (wifi_test == 0) {
							if (result == 1) {
								alert(response.message);
							}
							else if (result == 0) {
								alert(response.message);
							}
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!! Unable to save...');
				}
			});
		}

		function timerUpdateStatus() {
			timer1 = setInterval(function () {
				getDeviceParams(updateDevicesParams, noSensorData);
			}, 5000);
		}

		function updateDevicesParams(response) {
			$('#device_id').val(response.dev_id);

			$('#wifi_params_table_body')
				.css("text-decoration", "");

			var ip_type = "Dynamic";
			if (response.wf_ip_static == true) {
				ip_type = "Static";
			}

			var obj = {};
			obj['MAC ID'] = response.dev_mac_addr;
			obj['Mode'] = response.wf_mode;
			obj['SSID'] = response.wf_conn_ssid;
			obj['IP_Type'] = ip_type;
			obj['IP_Address'] = response.wf_ip_addr;
			obj['Gateway'] = response.wf_gw;
			obj['Subnet'] = response.wf_sn;
			obj['DNS'] = response.wf_dns;
			obj['WiFi Status'] = response.wf_status;
			obj['Signal'] = response.wf_rssi + "%";
			obj['Devices'] = response.wf_conn_devs;

			$("#wifi_params_table_body").html("");
			$.each(obj, function (key, value) {
				var tr = $("<tr></tr>");

				var td_key = $("<td></td>")
					.html(key + " :")
					.addClass("wifi_param_key");

				var td_value = $("<td></td>")
					.html(value)
					.addClass("wifi_param_value")
					.attr("id", "active_" + key)

				//If IP_Address, change color to red...
				if (key == "IP_Address") {
					td_value.addClass("param_ip_address");
				}

				//Set the font of IP_Address values to Courier...
				if (key == "IP_Address" || key == "Gateway" || key == "Subnet" || key == "DNS") {
					td_value.addClass("courier_new")
						.addClass("ip_address_class");
				}

				tr.append(td_key);
				tr.append(td_value);
				$("#wifi_params_table_body").append(tr);
			});
			enable_disable_copy_button();
			$("#loader_get_ip").css("display", "none");
		}

		function noSensorData(response) {
			console.log("POST Error...");
			$('#wifi_params_table_body')
				.css("text-decoration", "line-through")
		}

		$("#button_scan").on("click", function () {
			$("#table_body").html("");
			scan_wifi_devices();
		})

		function scan_wifi_devices() {
			var url = "/getWifiDevices";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickIoT/scanWifiDevices";
			}

			var type = 'POST';
			var data = {
				start_scan: true
			};

			$("#loader_scan").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_scan").css("display", "none");

					var result = response.result;

					if (result == 1) {
						show_wifi_list(response);
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_scan").css("display", "none");
					alert('POST Error!! Unable to get Wifi devices...');
				}
			});
		}

		function show_wifi_list(response) {
			$("#table_body").html("");

			$.each(response.list, function (idx, val) {
				var tr = $("<tr></tr>")
					.attr("data-ssid", val.ssid)
					.addClass("w_table_row")

				var th = $("<th scope='row'></th>")
					.html(idx + 1);

				var td1 = $("<td></td>")
					.html(val.ssid);

				var td2 = $("<td></td>")
					.html(val.rssi + "%");

				var td3 = $("<td></td>")
					.html(val.encryption);

				tr.append(th);
				tr.append(td1);
				tr.append(td2);
				tr.append(td3);
				$("#table_body").append(tr);
			});

			$('.w_table_row').on('click', function () {
				$("#wifi_ssid").val($(this).data("ssid"));
				$("#wifi_password").val("");
			});
		}

		//********* Call all start up functions after this line *******//
		// updateConfigFromFS(load_form_data);
		setTimeout(function () {
			updateWifiConfigFromFS(load_form_data);
		}, 500);

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
			timerUpdateStatus();
		}, 1000);
	});
</script>